=== examples/CMakeLists.txt ===
set(MODULE_PATH ${PROJECT_SOURCE_DIR}/src/modules)

add_subdirectory(test_window_bg)
add_subdirectory(test_wallpaper_color)
add_subdirectory(test_show_desktop)
add_subdirectory(test_window_cursor)
add_subdirectory(test_xdgport_wallpaper)
add_subdirectory(test_virtual_output)
add_subdirectory(test_pinch_handler)
add_subdirectory(test_hide_window)
add_subdirectory(test_data_control_manager)
add_subdirectory(test_window_overlapped)
add_subdirectory(test_capture)
add_subdirectory(test_window_appearance)
add_subdirectory(test_super_overlay_surface)
add_subdirectory(test_monitor_active_event)
add_subdirectory(test_primary_output)
add_subdirectory(test_multitaskview)
add_subdirectory(test_set_treeland_wallpaper)
add_subdirectory(test_color_control)
