=== debian/changelog ===
treeland (0.7.8) unstable; urgency=medium

  * [skip CI] Translate multitaskview.en_US.ts in tr
  * feat: optimize taskbar preview animation effects
  * fix: resolve window remove/resize blur on fractional DPR displays
  * fix: connect Helper::Session with Logind session
  * fix: synchronize wl_client destruction with WClient destruction
  * feat: Add logout cleanup
  * feat: support setting brightness & color temperature through
    treeland-output-manager-v1
  * chore: update find_package calls for Qt private modules for building
    with Qt 6.10

 -- rewine <luhongxu@uniontech.com>  Fri, 14 Nov 2025 11:35:06 +0800

treeland (0.7.7) unstable; urgency=medium

  * fix: mark animation as finished when skipping slide animation
  * fix: temporarily disable DockPreview animations
  * fix: resolve surface position drift during scale changes
  * refactor: Use swap member function instead of std::swap

 -- rewine <luhongxu@uniontech.com>  Fri, 07 Nov 2025 16:07:54 +0800

treeland (0.7.6) unstable; urgency=medium

  * refactor: implement atomic multi-output configuration
  * fix: occasional crash during recording toplevel
  * fix: use safeConnect for aboutToBeInvalidated
  * i18n: Updates for project TreeLand (#601)
  * refactor: Convert Session to shared_ptr and simplify session
    lifecycle
  * chore: Remove unused code & Add document
  * feat: Manage per-user Wayland/XWayland sessions via Helper::Session
  * feat: Add per-user XWayland session management
  * chore: add ASAN environment variables
  * feat: Expose XWayland surface process ID
  * chore: change Debian build environment to unstable
  * refactor: remove branch filter for workflow triggers
  * fix: fix build when treeland examples are enabled
  * fix: fix build failure on Arch Linux
  * fix: Disable minimize / maximize animation for window that doesn't
    belongs to current user
  * fix: fix private module inclusion on lower version of Qt
  * fix: compile errors on Arch for forward declared class
  * fix: include Qt private modules for Qt 6.11
  * feat: add real-time FPS display
  * feat: support start sessions other than treeland
  * feat: implement ext-session-lock-v1 support
  * feat(waylib): implement ext-session-lock-v1 protocol support
  * fix(waylib): Add missing override specifier in wlayersurface
  * fix(qwlroots): allow server side destruction of qw_session_lock_v1
  * fix: Delete useless display text in copy mode
  * fix: enhance output validation in restore copy mode
  * fix: use separate TreelandConfig for each user
  * fix: Ensure proper object destruction before app exit
  * fix: improve resource management for RenderControl
  * fix: fix heap-use-after-free on exit

 -- rewine <luhongxu@uniontech.com>  Thu, 30 Oct 2025 14:04:56 +0800
